package rocks.zipcode.quiz5.fundamentals;

import rocks.zipcode.quiz5.arrays.ArrayUtils;

import java.util.*;

/**
 * @author leon on 21/12/2018.
 */
public class StringUtils {
    public static Character getMiddleCharacter(String string) {
        return string.charAt(string.length()/2);
    }

    public static String capitalizeMiddleCharacter(String str) {
        int middle = str.length()/2;
        String upper = str.substring(middle, middle+1).toUpperCase();
        String[] strArray = str.split("");
        strArray[middle] = upper;
        String fin = "";
        for(String string : strArray){
            fin = fin.concat(string);
        }
        return fin;

    }

    public static String lowerCaseMiddleCharacter(String str) {
        int middle = str.length()/2;
        String upper = str.substring(middle, middle+1).toLowerCase();
        String[] strArray = str.split("");
        strArray[middle] = upper;
        String fin = "";
        for(String string : strArray){
            fin = fin.concat(string);
        }
        return fin;
    }

    public static Boolean isIsogram(String str) {
        Set<Character>  set = new HashSet<>();
        for(int i = 0; i < str.length(); i++) set.add(str.charAt(i));
        if(set.size() == str.length()) return true;
        return false;
    }

    public static Boolean hasDuplicateConsecutiveCharacters(String str) {
        String[] strArray = str.split("");
        String letter = strArray[0];
        for(int i = 1; i < strArray.length; i ++){
            if(letter.equals(strArray[i])){
                return true;
            } else {
                letter = strArray[i];
            }
        }
        return false;
    }

    public static String removeConsecutiveDuplicateCharacters(String str) {
        String[] strArray = str.split("");
        String letter = strArray[0];
        if(hasDuplicateConsecutiveCharacters(str)) {
            for (int i = 1; i < strArray.length; i++) {
                if (letter.equals(strArray[i])) {
                    strArray[i] = "";
                    strArray[i - 1] = "";
                } else {
                    letter = strArray[i];
                }
            }
            String fin = "";
            for (String i : strArray) {
                fin = fin.concat(i);
            }
            return fin;
        }
        return str;
    }

    public static String invertCasing(String str) {
        String[] strArray = str.split("");
        String fin = "";
        for(String string : strArray){
            if(isUpperCase(string)){
               String temp =  string.toLowerCase();
               fin = fin.concat(temp);
            }
            else if(!isUpperCase(string)){
               String temp = string.toUpperCase();
               fin = fin.concat(temp);
            }
        }
        return fin;
    }

    private static boolean isUpperCase(String s) {
        for (int i=0; i<s.length(); i++)
        {
            if (Character.isLowerCase(s.charAt(i)))
            {
                return false;
            }
        }
        return true;
    }
}